testerror.c File Reference
`#include <stdio.h>`
`#include <stdlib.h>`
`#include "SDL.h"`
Include dependency graph for testerror.c:

Go to the source code of this file.

## Functions

static void | quit (int rc)
int | ThreadFunc (void *data)
int | main (int argc, char *argv[])

## Variables

static int | alive = 0

## Function Documentation

## main()

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Definition at line 45 of file testerror.c.

References alive, NULL, quit(), SDL_CreateThread, SDL_Delay, SDL_GetError, SDL_Init, SDL_Log, SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO, SDL_LogError, SDL_LogSetPriority, SDL_Quit, SDL_SetError, SDL_WaitThread, and ThreadFunc().

{
SDL_Thread *thread;
/* Enable standard application logging */
SDL_LogSetPriority(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO);
/* Load the SDL library */
if (SDL_Init(0) < 0) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't initialize SDL: %s\n", SDL_GetError());
return (1);
}
/* Set the error value for the main thread */
SDL_SetError("No worries");
alive = 1;
thread = SDL_CreateThread(ThreadFunc, NULL, "#1");
if (thread == NULL) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't create thread: %s\n", SDL_GetError());
quit(1);
}
SDL_Delay(5 * 1000);
SDL_Log("Waiting for thread #1\n");
alive = 0;
SDL_WaitThread(thread, NULL);
SDL_Log("Main thread error string: %s\n", SDL_GetError());
SDL_Quit();
return (0);
}
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:113
SDL_LogError
#define SDL_LogError
Definition: SDL_dynapi_overrides.h:36
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
SDL_Quit
#define SDL_Quit
Definition: SDL_dynapi_overrides.h:58
ThreadFunc
int ThreadFunc(void *data)
Definition: testerror.c:31
SDL_LOG_PRIORITY_INFO
Definition: SDL_log.h:106
quit
static void quit(int rc)
Definition: testerror.c:24
SDL_CreateThread
#define SDL_CreateThread
Definition: SDL_dynapi_overrides.h:41
SDL_Delay
#define SDL_Delay
Definition: SDL_dynapi_overrides.h:486
SDL_LogSetPriority
#define SDL_LogSetPriority
Definition: SDL_dynapi_overrides.h:236
NULL
#define NULL
Definition: begin_code.h:164
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_Thread
Definition: SDL_thread_c.h:54
SDL_Init
#define SDL_Init
Definition: SDL_dynapi_overrides.h:54
SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66
SDL_WaitThread
#define SDL_WaitThread
Definition: SDL_dynapi_overrides.h:478
alive
static int alive
Definition: testerror.c:20

## quit()

static void quit | ( | int | rc | ) |

static

Definition at line 24 of file testerror.c.

References SDL_Quit, and SDLCALL.

Referenced by main().

{
SDL_Quit();
exit(rc);
}
SDL_Quit
#define SDL_Quit
Definition: SDL_dynapi_overrides.h:58

## ThreadFunc()

int ThreadFunc | ( | void * | data | ) |

Definition at line 31 of file testerror.c.

References alive, SDL_Delay, SDL_GetError, SDL_Log, SDL_SetError, and SDL_ThreadID.

Referenced by main().

{
/* Set the child thread error string */
SDL_SetError("Thread %s (%lu) had a problem: %s",
(char *) data, SDL_ThreadID(), "nevermind");
while (alive) {
SDL_Log("Thread '%s' is alive!\n", (char *) data);
SDL_Delay(1 * 1000);
}
SDL_Log("Child thread error string: %s\n", SDL_GetError());
return (0);
}
SDL_ThreadID
#define SDL_ThreadID
Definition: SDL_dynapi_overrides.h:475
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:113
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1974
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
SDL_Delay
#define SDL_Delay
Definition: SDL_dynapi_overrides.h:486
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
alive
static int alive
Definition: testerror.c:20

## Variable Documentation

## alive

int alive = 0

static

Definition at line 20 of file testerror.c.

Referenced by main(), and ThreadFunc().